#NoTrayIcon

#region
#AutoIt3Wrapper_icon=..\..\..\..\Programme\AutoIt3\Aut2Exe\Icons\AutoIt_Main_v9_48x48_RGB-A.ico
#AutoIt3Wrapper_outfile=Webserver.exe
#AutoIt3Wrapper_Compression=4
#endregion

#include <Helper.au3>
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

Global $fRunAu3Code = True
Global $iNewSocket, $iMainSocket
Global $fServerRun = False
Global $sRootDir = @ScriptDir & "\www\"
Global $sIP = @IPAddress1
Global $iPort = 80
Global $sServerAddress = "http://" & $sIP & ":" & $iPort & "/"
Global $iMaxUsers = 15
Global $sServerName = "Blume-HTTP-Server (" & @OSVersion & ") AutoIt " & @AutoItVersion
Global $aSocket[$iMaxUsers]
Global $sBuffer[$iMaxUsers]

For $iX = 0 to (UBound($aSocket) - 1)
	$aSocket[$iX] = -1
Next

TCPStartup()

$iMainSocket = TCPListen($sIP, $iPort)
If @error Then
	MsgBox(16, "Blume-HTTP-Server", "Der Server konnte nicht erstellt werden")
	Exit
EndIf
MsgBox(64, "Blume-HTTP-Server", StringFormat("Server-Infos:\n\nIP: %s\nPort: %i\n\n%s", $sIP, $iPort, $sServerAddress))


$hMainForm = GUICreate("Blume-HTTP-Server", 214, 85, -1, -1, -1, BitOR($WS_EX_TOOLWINDOW, $WS_EX_WINDOWEDGE))
$hStatusLabel = GUICtrlCreateLabel("Server Inaktiv", 8, 8, 196, 17, $SS_CENTER, $WS_EX_CLIENTEDGE)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
GUICtrlSetBkColor(-1, 0xFF0000)
$hButtonServerStart = GUICtrlCreateButton("Starten", 8, 32, 75, 25, $WS_GROUP)
GUICtrlSetColor(-1, 0x00FF00)
GUICtrlSetBkColor(-1, 0x008000)
$hButtonServerStop = GUICtrlCreateButton("Stoppen", 128, 32, 75, 25, $WS_GROUP)
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlSetBkColor(-1, 0x800000)
$hButtonInfo = GUICtrlCreateButton("??", 88, 32, 35, 25, $WS_GROUP)
GUICtrlSetColor(-1, 0xFFFF00)
GUICtrlSetBkColor(-1, 0x808000)
$hRunAu3 = GUICtrlCreateCheckbox("AutoIt-Code ausfhren?", 8, 60)
GUICtrlSetState(-1, $GUI_CHECKED)
GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			ConsoleWrite("** $GUI_EVENT_CLOSE = " & $GUI_EVENT_CLOSE & @CRLF)
			TCPCloseSocket($iNewSocket)
			TCPCloseSocket($iMainSocket)
			TCPShutdown()
			Exit
		Case $hButtonServerStart
			ConsoleWrite("** $hButtonServerStart = " & $hButtonServerStart & @CRLF)
			GUICtrlSetBkColor($hStatusLabel, 0x00FF00)
			GUICtrlSetData($hStatusLabel, "Server Aktiv")
			$fServerRun = True
			AdlibRegister("_Server", 100)
		Case $hButtonServerStop
			ConsoleWrite("** $hButtonServerStop = " & $hButtonServerStop & @CRLF)
			GUICtrlSetBkColor($hStatusLabel, 0xFF0000)
			GUICtrlSetData($hStatusLabel, "Server Inaktiv")
			AdlibUnRegister("_Server")
		Case $hRunAu3
			$fRunAu3Code = Not $fRunAu3Code
			ConsoleWrite("** $fRunAu3Code = " & $fRunAu3Code & @CRLF)
		Case $hButtonInfo
			ConsoleWrite("** $hButtonInfo = " & $hButtonInfo & @CRLF)
			MsgBox(64, "Blume-HTTP-Server", StringFormat("Blume-HTTP-Server\nCopyright (2010): DjBlume\n\nLizenz: CC", ""))
	EndSwitch
WEnd

Func _Server()
	If $fServerRun Then
		$iNewSocket = TCPAccept($iMainSocket)

		If $iNewSocket >= 0 Then
			For $iX = 0 To UBound($aSocket) - 1
				If $aSocket[$iX] = -1 Then
					$aSocket[$iX] = $iNewSocket
					ExitLoop
				EndIf
			Next
		EndIf

		For $iX = 0 To UBound($aSocket) - 1
			If $aSocket[$iX] = -1 Then ContinueLoop
			$sNewData = TCPRecv($aSocket[$iX], 1024)
			If @error Then
				$aSocket[$iX] = -1
				ContinueLoop
			ElseIf $sNewData Then
				$sBuffer[$iX] &= $sNewData

				If StringInStr(StringStripCR($sBuffer[$iX]), @LF & @LF) Then
					$sFirstLine = StringLeft($sBuffer[$iX], StringInStr($sBuffer[$iX], @LF))
					$sRequestType = StringLeft($sFirstLine, StringInStr($sFirstLine, " ") - 1)

					If $sRequestType = "GET" Then
						$sRequest = StringTrimRight(StringTrimLeft($sFirstLine, 4), 11)
						If StringInStr(StringReplace($sRequest, "\", "/"), "/.") Then
							_HTTP_SendFileNotFoundError($aSocket[$iX])
						Else

							If $sRequest = "/" Then
								$sRequest = "/index.html"
							EndIf

							$sRequest = StringReplace($sRequest, "/", "\")
							If FileExists($sRootDir & "\" & $sRequest) Then
								$sFileType = StringRight($sRequest, 4)

								Switch $sFileType
									Case "html", ".htm"
										_HTTP_SendFile($aSocket[$iX], $sRootDir & $sRequest, "text/html")
									Case ".css"
										_HTTP_SendFile($aSocket[$iX], $sRootDir & $sRequest, "text/css")
									Case ".jpg", "jpeg"
										_HTTP_SendFile($aSocket[$iX], $sRootDir & $sRequest, "image/jpeg")
									Case ".png"
										_HTTP_SendFile($aSocket[$iX], $sRootDir & $sRequest, "image/png")
									Case Else
										_HTTP_SendFile($aSocket[$iX], $sRootDir & $sRequest, "application/octet-stream")
								EndSwitch

							Else
								_HTTP_SendFileNotFoundError($aSocket[$iX])
							EndIf

						EndIf

					EndIf

					$sBuffer[$iX] = ""
					$aSocket[$iX] = -1
				EndIf

			EndIf
		Next
	EndIf
EndFunc   ;==>_Server