;// ALLE Funktion in dieser AutoIt-Datei auer _HTTP_SendFileNotFoundError() sind von Mandar aus dem EN-Forum! //
#include <String.au3>

Func _HTTP_ConvertString(ByRef $sInput)
	$sInput = StringReplace($sInput, '+', ' ')
	StringReplace($sInput, '%', '')
	For $t = 0 To @extended
		$Find_Char = StringLeft(StringTrimLeft($sInput, StringInStr($sInput, '%')), 2)
		$sInput = StringReplace($sInput, '%' & $Find_Char, Chr(Dec($Find_Char)))
	Next
EndFunc   ;==>_HTTP_ConvertString

Func _HTTP_SendHTML($hSocket, $sHTML, $sReply = "200 OK")
	_HTTP_SendData($hSocket, Binary($sHTML), "text/html", $sReply)
EndFunc   ;==>_HTTP_SendHTML

Func _HTTP_SendFile($hSocket, $sFileLoc, $sMimeType, $sReply = "200 OK")
	Local $hFile, $sImgBuffer, $sPacket, $a, $sInterpreter_AU3, $hInterpreterProcess
	ConsoleWrite("* Client: Sende Datei (" & $sFileLoc & ")" & @CRLF)
	$hFile = FileOpen($sFileLoc, 16)
	$bFileData = FileRead($hFile)
	FileClose($hFile)

	If $fRunAu3Code Then
		$sInterpreter_AU3 = BinaryToString($bFileData)
		$sInterpreter_AU3 = _StringBetween($sInterpreter_AU3, "<?au3", "au3?>")

		If Not @error Then
			FileWrite("C:\Temp.au3", $sInterpreter_AU3[0])
			$hInterpreterProcess = ShellExecute(@AutoItExe, 'C:\Temp.au3', $sRootDir)
			$sInterpreter_AU3 = StringRegExpReplace($sInterpreter_AU3, "<?au3 (*.?) au3?>", "")
			FileDelete("C:\Temp.au3")
			_HTTP_SendData($hSocket, $sInterpreter_AU3, $sMimeType, $sReply)
		EndIf
	Else
		_HTTP_SendData($hSocket, $bFileData, $sMimeType, $sReply)
	EndIf
EndFunc   ;==>_HTTP_SendFile

Func _HTTP_SendData($hSocket, $bData, $sMimeType, $sReply = "200 OK")
	$sPacket = Binary("HTTP/1.1 " & $sReply & @CRLF & _
			"Server: Blume-HTTP-Server" & @CRLF & _
			"Connection: close" & @CRLF & _
			"Content-Lenght: " & BinaryLen($bData) & @CRLF & _
			"Content-Type: " & $sMimeType & @CRLF & _
			@CRLF)
	TCPSend($hSocket, $sPacket)
	While BinaryLen($bData)
		$a = TCPSend($hSocket, $bData)
		$bData = BinaryMid($bData, $a + 1, BinaryLen($bData) - $a)
	WEnd
	$sPacket = Binary(@CRLF & @CRLF)
	TCPSend($hSocket, $sPacket)
	TCPCloseSocket($hSocket)
EndFunc   ;==>_HTTP_SendData

Func _HTTP_SendFileNotFoundError($hSocket)
	Local $s404Loc = $sRootDir & "\404.html"
	If (FileExists($s404Loc)) Then
		_HTTP_SendFile($hSocket, $s404Loc, "text/html")
	Else
		_HTTP_SendHTML($hSocket, "404-Fehler: " & @CRLF & @CRLF & "Die Datei wurde nicht gefunden!")
	EndIf
EndFunc   ;==>_HTTP_SendFileNotFoundError